#include <ib.h>
#include <ibP.h>

PUBLIC int ibBdChrConfig(int ud, int base,int irq,int dma, int dmabuf)
{

  if( ibBoardOpen( CONF(ud,board) ) & ERR ){
    ibXsta = ibarg.ib_ibsta | ERR;
    ibXerr = EDVR;
    ibXcnt = errno;
    ibPutErrlog(ud,"ibBdChrConfig");
  } else {

    if( base != 0 )   ibBoardFunc(CONF(ud,board),CFCBASE, base);
    if( irq  != 0 )   ibBoardFunc(CONF(ud,board),CFCIRQ , irq);
    if( dma  != 0 )   ibBoardFunc(CONF(ud,board),CFCDMA , dma);
    if(dmabuf > 0 ) {
        if( dmabuf % 1024 != 0 ) {
           ibPutMsg(" Size of DMA Buffer not dividable by 1024 ");
           return( ERR );
        }
        else {
           if( ibBoardFunc(CONF(ud,board),CFCDMABUFFER ,dmabuf) & ERR ) {
	     ibPutMsg(" Problem during DMA-Buffer allocation ");
	   }
        }


    }   

    if (!(ibXsta & ERR)) {
      ibXerr = EDVR;
      ibXcnt = 0;
      ibPutErrlog(ud,"ibBdChrConfig");
    }
    ibBoardClose( CONF(ud,board) );
  }
  return ibXsta;
}


